ProxiedKeyedObjectPool (Apache Commons Pool 2.11.1 API)

org.apache.commons.pool2.proxy

## Class ProxiedKeyedObjectPool<K,V>

- java.lang.Object
- - org.apache.commons.pool2.proxy.ProxiedKeyedObjectPool<K,V>

- Type Parameters:
    `K` - type of the key
    `V` - type of the pooled object
  All Implemented Interfaces:
    Closeable, AutoCloseable, KeyedObjectPool<K,V>

      public class ProxiedKeyedObjectPool<K,V>
      extends Object
      implements KeyedObjectPool<K,V>

  Create a new keyed object pool where the pooled objects are wrapped in proxies allowing better control of pooled objects and in particular the prevention of the continued use of an object by a client after that client returns the object to the pool.
  Since:
    2.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ProxiedKeyedObjectPool(KeyedObjectPool<K,V> pool, org.apache.commons.pool2.proxy.ProxySource<V> proxySource)` Constructs a new proxied object pool.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addObject(K key)` Creates an object using the `factory` or other implementation dependent mechanism, passivate it, and then place it in the idle object pool.
    `V` | `borrowObject(K key)` Borrows an instance from this pool for the specified `key`.
    `void` | `clear()` Clears the pool, removing all pooled instances (optional operation).
    `void` | `clear(K key)` Clears the specified pool, removing all pooled instances corresponding to the given `key` (optional operation).
    `void` | `close()` Closes this pool, and free any resources associated with it.
    `int` | `getNumActive()` Gets the total number of instances currently borrowed from this pool but not yet returned.
    `int` | `getNumActive(K key)` Gets the number of instances currently borrowed from but not yet returned to the pool corresponding to the given `key`.
    `int` | `getNumIdle()` Gets the total number of instances currently idle in this pool.
    `int` | `getNumIdle(K key)` Gets the number of instances corresponding to the given `key` currently idle in this pool.
    `void` | `invalidateObject(K key, V proxy)` Invalidates an object from the pool.
    `void` | `returnObject(K key, V proxy)` Return an instance to the pool.
    `String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.commons.pool2.KeyedObjectPool

      `addObjects, addObjects, invalidateObject`

- - ### Constructor Detail

    - #### ProxiedKeyedObjectPool

          public ProxiedKeyedObjectPool(KeyedObjectPool<K,V> pool,
                                        org.apache.commons.pool2.proxy.ProxySource<V> proxySource)

      Constructs a new proxied object pool.
      Parameters:
        `pool` - The object pool to wrap
        `proxySource` - The source of the proxy objects

  - ### Method Detail

    - #### addObject

          public void addObject(K key)
                         throws Exception,
                                IllegalStateException,
                                UnsupportedOperationException

      Description copied from interface: `KeyedObjectPool`
      Creates an object using the `factory` or other implementation dependent mechanism, passivate it, and then place it in the idle object pool. `addObject` is useful for "pre-loading" a pool with idle objects (Optional operation).
      Specified by:
        `addObject` in interface `KeyedObjectPool<K,V>`
      Parameters:
        `key` - the key a new instance should be added to
      Throws:
        `Exception` - when `KeyedPooledObjectFactory.makeObject(K)` fails.
        `IllegalStateException` - after `KeyedObjectPool.close()` has been called on this pool.
        `UnsupportedOperationException` - when this pool cannot add new idle objects.

    - #### borrowObject

          public V borrowObject(K key)
                         throws Exception,
                                NoSuchElementException,
                                IllegalStateException

      Description copied from interface: `KeyedObjectPool`
      Borrows an instance from this pool for the specified `key`.

      Instances returned from this method will have been either newly created with `makeObject` or will be a previously idle object and have been activated with `activateObject` and then (optionally) validated with `validateObject`.

      By contract, clients must return the borrowed object using `returnObject`, `invalidateObject`, or a related method as defined in an implementation or sub-interface, using a `key` that is `equivalent` to the one used to borrow the instance in the first place.

      The behavior of this method when the pool has been exhausted is not strictly specified (although it may be specified by implementations).

      Specified by:
        `borrowObject` in interface `KeyedObjectPool<K,V>`
      Parameters:
        `key` - the key used to obtain the object
      Returns:
        an instance from this pool.
      Throws:
        `IllegalStateException` - after `close` has been called on this pool
        `Exception` - when `makeObject` throws an exception
        `NoSuchElementException` - when the pool is exhausted and cannot or will not return another instance

    - #### clear

          public void clear()
                     throws Exception,
                            UnsupportedOperationException

      Description copied from interface: `KeyedObjectPool`
      Clears the pool, removing all pooled instances (optional operation).
      Specified by:
        `clear` in interface `KeyedObjectPool<K,V>`
      Throws:
        `UnsupportedOperationException` - when this implementation doesn't support the operation
        `Exception` - if the pool cannot be cleared

    - #### clear

          public void clear(K key)
                     throws Exception,
                            UnsupportedOperationException

      Description copied from interface: `KeyedObjectPool`
      Clears the specified pool, removing all pooled instances corresponding to the given `key` (optional operation).
      Specified by:
        `clear` in interface `KeyedObjectPool<K,V>`
      Parameters:
        `key` - the key to clear
      Throws:
        `UnsupportedOperationException` - when this implementation doesn't support the operation
        `Exception` - if the key cannot be cleared

    - #### close

          public void close()

      Description copied from interface: `KeyedObjectPool`
      Closes this pool, and free any resources associated with it.

      Calling `addObject` or `borrowObject` after invoking this method on a pool will cause them to throw an `IllegalStateException`.

      Implementations should silently fail if not all resources can be freed.

      Specified by:
        `close` in interface `Closeable`
      Specified by:
        `close` in interface `AutoCloseable`
      Specified by:
        `close` in interface `KeyedObjectPool<K,V>`

    - #### getNumActive

          public int getNumActive()

      Description copied from interface: `KeyedObjectPool`
      Gets the total number of instances currently borrowed from this pool but not yet returned. Returns a negative value if this information is not available.
      Specified by:
        `getNumActive` in interface `KeyedObjectPool<K,V>`
      Returns:
        the total number of instances currently borrowed from this pool but not yet returned.

    - #### getNumActive

          public int getNumActive(K key)

      Description copied from interface: `KeyedObjectPool`
      Gets the number of instances currently borrowed from but not yet returned to the pool corresponding to the given `key`. Returns a negative value if this information is not available.
      Specified by:
        `getNumActive` in interface `KeyedObjectPool<K,V>`
      Parameters:
        `key` - the key to query
      Returns:
        the number of instances currently borrowed from but not yet returned to the pool corresponding to the given `key`.

    - #### getNumIdle

          public int getNumIdle()

      Description copied from interface: `KeyedObjectPool`
      Gets the total number of instances currently idle in this pool. Returns a negative value if this information is not available.
      Specified by:
        `getNumIdle` in interface `KeyedObjectPool<K,V>`
      Returns:
        the total number of instances currently idle in this pool.

    - #### getNumIdle

          public int getNumIdle(K key)

      Description copied from interface: `KeyedObjectPool`
      Gets the number of instances corresponding to the given `key` currently idle in this pool. Returns a negative value if this information is not available.
      Specified by:
        `getNumIdle` in interface `KeyedObjectPool<K,V>`
      Parameters:
        `key` - the key to query
      Returns:
        the number of instances corresponding to the given `key` currently idle in this pool.

    - #### invalidateObject

          public void invalidateObject(K key,
                                       V proxy)
                                throws Exception

      Description copied from interface: `KeyedObjectPool`
      Invalidates an object from the pool.

      By contract, `obj` must have been obtained using `borrowObject` or a related method as defined in an implementation or sub-interface using a `key` that is equivalent to the one used to borrow the `Object` in the first place.

      This method should be used when an object that has been borrowed is determined (due to an exception or other problem) to be invalid.

      Specified by:
        `invalidateObject` in interface `KeyedObjectPool<K,V>`
      Parameters:
        `key` - the key used to obtain the object
        `proxy` - a `borrowed` instance to be returned.
      Throws:
        `Exception` - if the instance cannot be invalidated

    - #### returnObject

          public void returnObject(K key,
                                   V proxy)
                            throws Exception

      Description copied from interface: `KeyedObjectPool`
      Return an instance to the pool. By contract, `obj` must have been obtained using `borrowObject` or a related method as defined in an implementation or sub-interface using a `key` that is equivalent to the one used to borrow the instance in the first place.
      Specified by:
        `returnObject` in interface `KeyedObjectPool<K,V>`
      Parameters:
        `key` - the key used to obtain the object
        `proxy` - a `borrowed` instance to be returned.
      Throws:
        `IllegalStateException` - if an attempt is made to return an object to the pool that is in any state other than allocated (i.e. borrowed). Attempting to return an object more than once or attempting to return an object that was never borrowed from the pool will trigger this exception.
        `Exception` - if an instance cannot be returned to the pool

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`
      Since:
        2.4.3

Copyright © 2001–2021 The Apache Software Foundation. All rights reserved.